#include <inline/stub.h>
#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL extern struct ExpansionBase * ExpansionBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME ExpansionBase
#endif
__inline static void AddConfigDev(BASE_PAR_DECL struct ConfigDev* configDev)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct ConfigDev* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = configDev;
	__asm volatile ("
	jsr a6@(-0x1e)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
#ifdef PRIVATE
#endif
__inline static long AllocBoardMem(BASE_PAR_DECL long slotSpec)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	d0 = slotSpec;
	__asm volatile ("
	jsr a6@(-0x2a)"
	: "=r" (res)
	: "r" (a6), "r" (d0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static struct ConfigDev * AllocConfigDev(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register struct ConfigDev * res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x30)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static long AllocExpansionMem(BASE_PAR_DECL long numSlots, long SlotAlign, long SlotOffset)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");

	a6 = BASE_NAME;
	d0 = numSlots;
	d1 = SlotAlign;
	d2 = SlotOffset;
	__asm volatile ("
	jsr a6@(-0x36)"
	: "=r" (res)
	: "r" (a6), "r" (d0), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "d2");
	return res;
}
__inline static long ConfigBoard(BASE_PAR_DECL long board, struct ConfigDev* configDev)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register long a0 __asm("a0");
	register struct ConfigDev* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = board;
	a1 = configDev;
	__asm volatile ("
	jsr a6@(-0x3c)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*a1=*a1;
	return res;
}
__inline static long ConfigChain(BASE_PAR_DECL long baseAddr)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register long a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = baseAddr;
	__asm volatile ("
	jsr a6@(-0x42)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static struct ConfigDev * FindConfigDev(BASE_PAR_DECL struct ConfigDev* oldConfigDev, long manufacturer, long product)
{
	BASE_EXT_DECL
	register struct ConfigDev * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct ConfigDev* a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = oldConfigDev;
	d0 = manufacturer;
	d1 = product;
	__asm volatile ("
	jsr a6@(-0x48)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
	return res;
}
__inline static void FreeBoardMem(BASE_PAR_DECL long startSlot, long slotSpec)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	d0 = startSlot;
	d1 = slotSpec;
	__asm volatile ("
	jsr a6@(-0x4e)"
	: /* no output */
	: "r" (a6), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
}
__inline static void FreeConfigDev(BASE_PAR_DECL struct ConfigDev* configDev)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct ConfigDev* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = configDev;
	__asm volatile ("
	jsr a6@(-0x54)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static void FreeExpansionMem(BASE_PAR_DECL long startSlot, long numSlots)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	d0 = startSlot;
	d1 = numSlots;
	__asm volatile ("
	jsr a6@(-0x5a)"
	: /* no output */
	: "r" (a6), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
}
__inline static long ReadExpansionByte(BASE_PAR_DECL const char* board, long offset)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = board;
	d0 = offset;
	__asm volatile ("
	jsr a6@(-0x60)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static long ReadExpansionRom(BASE_PAR_DECL const char* board, struct ConfigDev* configDev)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");
	register struct ConfigDev* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = board;
	a1 = configDev;
	__asm volatile ("
	jsr a6@(-0x66)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*a1=*a1;
	return res;
}
__inline static void RemConfigDev(BASE_PAR_DECL struct ConfigDev* configDev)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct ConfigDev* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = configDev;
	__asm volatile ("
	jsr a6@(-0x6c)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static long WriteExpansionByte(BASE_PAR_DECL const char* board, long offset, long byte)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = board;
	d0 = offset;
	d1 = byte;
	__asm volatile ("
	jsr a6@(-0x72)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void ObtainConfigBinding(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x78)"
	: /* no output */
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
}
__inline static void ReleaseConfigBinding(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x7e)"
	: /* no output */
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
}
__inline static void SetCurrentBinding(BASE_PAR_DECL struct CurrentBinding* currentBinding, long bindingSize)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct CurrentBinding* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = currentBinding;
	d0 = bindingSize;
	__asm volatile ("
	jsr a6@(-0x84)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static long GetCurrentBinding(BASE_PAR_DECL struct CurrentBinding* currentBinding, long bindingSize)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct CurrentBinding* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = currentBinding;
	d0 = bindingSize;
	__asm volatile ("
	jsr a6@(-0x8a)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
	return res;
}
__inline static struct DeviceNode * MakeDosNode(BASE_PAR_DECL long* parmPacket)
{
	BASE_EXT_DECL
	register struct DeviceNode * res __asm("d0");
	register void *a6 __asm ("a6");
	register long* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = parmPacket;
	__asm volatile ("
	jsr a6@(-0x90)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
	return res;
}
__inline static long AddDosNode(BASE_PAR_DECL long bootPri, long flags, struct DeviceNode* dosNode)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register struct DeviceNode* a0 __asm("a0");

	a6 = BASE_NAME;
	d0 = bootPri;
	d1 = flags;
	a0 = dosNode;
	__asm volatile ("
	jsr a6@(-0x96)"
	: "=r" (res)
	: "r" (a6), "r" (d0), "r" (d1), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
	return res;
}
#undef BASE_EXT_DECL
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME
