#include <inline/stub.h>
#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL extern struct Library * IconBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME IconBase
#endif
__inline static struct WBObject * GetWBObject(BASE_PAR_DECL const char* name)
{
	BASE_EXT_DECL
	register struct WBObject * res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = name;
	__asm volatile ("
	jsr a6@(-0x1e)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static long PutWBObject(BASE_PAR_DECL const char* name, struct WBObject* object)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");
	register struct WBObject* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = name;
	a1 = object;
	__asm volatile ("
	jsr a6@(-0x24)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char *)a1=*(char *)a1;
	return res;
}
__inline static long GetIcon(BASE_PAR_DECL const char* name, struct DiskObject* icon, struct FreeList* freelist)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");
	register struct DiskObject* a1 __asm("a1");
	register struct FreeList* a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = name;
	a1 = icon;
	a2 = freelist;
	__asm volatile ("
	jsr a6@(-0x2a)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2)
	: "d0", "d1", "a0", "a1", "a2");
	*(char *)a1=*(char *)a1;*(char *)a2=*(char *)a2;
	return res;
}
__inline static long PutIcon(BASE_PAR_DECL const char* name, struct DiskObject* icon)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");
	register struct DiskObject* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = name;
	a1 = icon;
	__asm volatile ("
	jsr a6@(-0x30)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char *)a1=*(char *)a1;
	return res;
}
__inline static void FreeFreeList(BASE_PAR_DECL struct FreeList* freelist)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct FreeList* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = freelist;
	__asm volatile ("
	jsr a6@(-0x36)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char *)a0=*(char *)a0;
}
__inline static void FreeWBObject(BASE_PAR_DECL struct WBObject* WBObject)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct WBObject* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = WBObject;
	__asm volatile ("
	jsr a6@(-0x3c)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char *)a0=*(char *)a0;
}
__inline static struct WBObject * AllocWBObject(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register struct WBObject * res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x42)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void AddFreeList(BASE_PAR_DECL struct FreeList* freelist, char* mem, long size)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct FreeList* a0 __asm("a0");
	register char* a1 __asm("a1");
	register long a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = freelist;
	a1 = mem;
	a2 = size;
	__asm volatile ("
	jsr a6@(-0x48)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2)
	: "d0", "d1", "a0", "a1", "a2");
	*(char *)a0=*(char *)a0;*(char *)a1=*(char *)a1;
}
__inline static struct DiskObject * GetDiskObject(BASE_PAR_DECL const char* name)
{
	BASE_EXT_DECL
	register struct DiskObject * res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = name;
	__asm volatile ("
	jsr a6@(-0x4e)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static long PutDiskObject(BASE_PAR_DECL const char* name, struct DiskObject* diskobj)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");
	register struct DiskObject* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = name;
	a1 = diskobj;
	__asm volatile ("
	jsr a6@(-0x54)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char *)a1=*(char *)a1;
	return res;
}
__inline static void FreeDiskObject(BASE_PAR_DECL struct DiskObject* diskobj)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct DiskObject* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = diskobj;
	__asm volatile ("
	jsr a6@(-0x5a)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char *)a0=*(char *)a0;
}
__inline static char * FindToolType(BASE_PAR_DECL char** toolTypeArray, const char* typeName)
{
	BASE_EXT_DECL
	register char * res __asm("d0");
	register void *a6 __asm ("a6");
	register char** a0 __asm("a0");
	register const char* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = toolTypeArray;
	a1 = typeName;
	__asm volatile ("
	jsr a6@(-0x60)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char *)a0=*(char *)a0;
	return res;
}
__inline static long MatchToolValue(BASE_PAR_DECL char* typeString, char* value)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register char* a0 __asm("a0");
	register char* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = typeString;
	a1 = value;
	__asm volatile ("
	jsr a6@(-0x66)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char *)a0=*(char *)a0;*(char *)a1=*(char *)a1;
	return res;
}
__inline static char * BumpRevision(BASE_PAR_DECL const char* newname, const char* oldname)
{
	BASE_EXT_DECL
	register char * res __asm("d0");
	register void *a6 __asm ("a6");
	register const char* a0 __asm("a0");
	register const char* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = newname;
	a1 = oldname;
	__asm volatile ("
	jsr a6@(-0x6c)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	return res;
}
#undef BASE_EXT_DECL
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME
