#include <inline/stub.h>
#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL extern struct IntuitionBase * IntuitionBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME IntuitionBase
#endif
__inline static void OpenIntuition(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x1e)"
	: /* no output */
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
}
__inline static struct InputEvent * Intuition(BASE_PAR_DECL struct InputEvent* ievent)
{
	BASE_EXT_DECL
	register struct InputEvent * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct InputEvent* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = ievent;
	__asm volatile ("
	jsr a6@(-0x24)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
	return res;
}
__inline static long AddGadget(BASE_PAR_DECL struct Window* AddPtr, struct Gadget* Gadget, long Position)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register struct Gadget* a1 __asm("a1");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = AddPtr;
	a1 = Gadget;
	d0 = Position;
	__asm volatile ("
	jsr a6@(-0x2a)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;
	return res;
}
__inline static long ClearDMRequest(BASE_PAR_DECL struct Window* Window)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Window;
	__asm volatile ("
	jsr a6@(-0x30)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
	return res;
}
__inline static void ClearMenuStrip(BASE_PAR_DECL struct Window* Window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Window;
	__asm volatile ("
	jsr a6@(-0x36)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void ClearPointer(BASE_PAR_DECL struct Window* Window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Window;
	__asm volatile ("
	jsr a6@(-0x3c)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void CloseScreen(BASE_PAR_DECL struct Screen* Screen)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Screen* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Screen;
	__asm volatile ("
	jsr a6@(-0x42)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void CloseWindow(BASE_PAR_DECL struct Window* Window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Window;
	__asm volatile ("
	jsr a6@(-0x48)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static long CloseWorkBench(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x4e)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void CurrentTime(BASE_PAR_DECL long* Seconds, long* Micros)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register long* a0 __asm("a0");
	register long* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = Seconds;
	a1 = Micros;
	__asm volatile ("
	jsr a6@(-0x54)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;
}
__inline static long DisplayAlert(BASE_PAR_DECL long AlertNumber, const char* String, long Height)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register long d0 __asm("d0");
	register const char* a0 __asm("a0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	d0 = AlertNumber;
	a0 = String;
	d1 = Height;
	__asm volatile ("
	jsr a6@(-0x5a)"
	: "=r" (res)
	: "r" (a6), "r" (d0), "r" (a0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void DisplayBeep(BASE_PAR_DECL struct Screen* Screen)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Screen* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Screen;
	__asm volatile ("
	jsr a6@(-0x60)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static long DoubleClick(BASE_PAR_DECL long sseconds, long smicros, long cseconds, long cmicros)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");
	register long d3 __asm("d3");

	a6 = BASE_NAME;
	d0 = sseconds;
	d1 = smicros;
	d2 = cseconds;
	d3 = cmicros;
	__asm volatile ("
	jsr a6@(-0x66)"
	: "=r" (res)
	: "r" (a6), "r" (d0), "r" (d1), "r" (d2), "r" (d3)
	: "d0", "d1", "a0", "a1", "d2", "d3");
	return res;
}
__inline static void DrawBorder(BASE_PAR_DECL struct RastPort* RPort, const struct Border* Border, long LeftOffset, long TopOffset)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct RastPort* a0 __asm("a0");
	register const struct Border* a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = RPort;
	a1 = Border;
	d0 = LeftOffset;
	d1 = TopOffset;
	__asm volatile ("
	jsr a6@(-0x6c)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void DrawImage(BASE_PAR_DECL struct RastPort* RPort, const struct Image* Image, long LeftOffset, long TopOffset)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct RastPort* a0 __asm("a0");
	register const struct Image* a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = RPort;
	a1 = Image;
	d0 = LeftOffset;
	d1 = TopOffset;
	__asm volatile ("
	jsr a6@(-0x72)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void EndRequest(BASE_PAR_DECL struct Requester* requester, struct Window* window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Requester* a0 __asm("a0");
	register struct Window* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = requester;
	a1 = window;
	__asm volatile ("
	jsr a6@(-0x78)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;
}
__inline static struct Preferences * GetDefPrefs(BASE_PAR_DECL struct Preferences* preferences, long size)
{
	BASE_EXT_DECL
	register struct Preferences * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Preferences* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = preferences;
	d0 = size;
	__asm volatile ("
	jsr a6@(-0x7e)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
	return res;
}
__inline static struct Preferences * GetPrefs(BASE_PAR_DECL struct Preferences* preferences, long size)
{
	BASE_EXT_DECL
	register struct Preferences * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Preferences* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = preferences;
	d0 = size;
	__asm volatile ("
	jsr a6@(-0x84)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
	return res;
}
__inline static void InitRequester(BASE_PAR_DECL struct Requester* req)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Requester* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = req;
	__asm volatile ("
	jsr a6@(-0x8a)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static struct MenuItem * ItemAddress(BASE_PAR_DECL const struct Menu* MenuStrip, long MenuNumber)
{
	BASE_EXT_DECL
	register struct MenuItem * res __asm("d0");
	register void *a6 __asm ("a6");
	register const struct Menu* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = MenuStrip;
	d0 = MenuNumber;
	__asm volatile ("
	jsr a6@(-0x90)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void ModifyIDCMP(BASE_PAR_DECL struct Window* Window, long Flags)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = Window;
	d0 = Flags;
	__asm volatile ("
	jsr a6@(-0x96)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void ModifyProp(BASE_PAR_DECL struct Gadget* Gadget, struct Window* Ptr, struct Requester* Req, long Flags, long HPos, long VPos, long HBody, long VBody)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Gadget* a0 __asm("a0");
	register struct Window* a1 __asm("a1");
	register struct Requester* a2 __asm("a2");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");
	register long d3 __asm("d3");
	register long d4 __asm("d4");

	a6 = BASE_NAME;
	a0 = Gadget;
	a1 = Ptr;
	a2 = Req;
	d0 = Flags;
	d1 = HPos;
	d2 = VPos;
	d3 = HBody;
	d4 = VBody;
	__asm volatile ("" : /* no input */
	: "r" (a0));
	__asm volatile ("
	jsr a6@(-0x9c)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2), "r" (d0), "r" (d1), "r" (d2), "r" (d3)
	: "d0", "d1", "a0", "a1", "a2", "d2", "d3", "d4");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;*(char*)a2=*(char*)a2;
}
__inline static void MoveScreen(BASE_PAR_DECL struct Screen* Screen, long dx, long dy)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Screen* a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = Screen;
	d0 = dx;
	d1 = dy;
	__asm volatile ("
	jsr a6@(-0xa2)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void MoveWindow(BASE_PAR_DECL struct Window* window, long dx, long dy)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = window;
	d0 = dx;
	d1 = dy;
	__asm volatile ("
	jsr a6@(-0xa8)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void OffGadget(BASE_PAR_DECL struct Gadget* Gadget, struct Window* Ptr, struct Requester* Req)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Gadget* a0 __asm("a0");
	register struct Window* a1 __asm("a1");
	register struct Requester* a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = Gadget;
	a1 = Ptr;
	a2 = Req;
	__asm volatile ("
	jsr a6@(-0xae)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2)
	: "d0", "d1", "a0", "a1", "a2");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;*(char*)a2=*(char*)a2;
}
__inline static void OffMenu(BASE_PAR_DECL struct Window* Window, long MenuNumber)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = Window;
	d0 = MenuNumber;
	__asm volatile ("
	jsr a6@(-0xb4)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void OnGadget(BASE_PAR_DECL struct Gadget* Gadget, struct Window* Ptr, struct Requester* Req)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Gadget* a0 __asm("a0");
	register struct Window* a1 __asm("a1");
	register struct Requester* a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = Gadget;
	a1 = Ptr;
	a2 = Req;
	__asm volatile ("
	jsr a6@(-0xba)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2)
	: "d0", "d1", "a0", "a1", "a2");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;*(char*)a2=*(char*)a2;
}
__inline static void OnMenu(BASE_PAR_DECL struct Window* Window, long MenuNumber)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = Window;
	d0 = MenuNumber;
	__asm volatile ("
	jsr a6@(-0xc0)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static struct Screen* OpenScreen(BASE_PAR_DECL const struct NewScreen* OSargs)
{
	BASE_EXT_DECL
	register struct Screen* res __asm("d0");
	register void *a6 __asm ("a6");
	register const struct NewScreen* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = OSargs;
	__asm volatile ("
	jsr a6@(-0xc6)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static struct Window* OpenWindow(BASE_PAR_DECL const struct NewWindow* OWargs)
{
	BASE_EXT_DECL
	register struct Window* res __asm("d0");
	register void *a6 __asm ("a6");
	register const struct NewWindow* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = OWargs;
	__asm volatile ("
	jsr a6@(-0xcc)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static struct Screen* OpenWorkBench(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register struct Screen* res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0xd2)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void PrintIText(BASE_PAR_DECL struct RastPort* rp, const struct IntuiText* itext, long left, long top)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct RastPort* a0 __asm("a0");
	register const struct IntuiText* a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = rp;
	a1 = itext;
	d0 = left;
	d1 = top;
	__asm volatile ("
	jsr a6@(-0xd8)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void RefreshGadgets(BASE_PAR_DECL struct Gadget* Gadgets, struct Window* Ptr, struct Requester* Req)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Gadget* a0 __asm("a0");
	register struct Window* a1 __asm("a1");
	register struct Requester* a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = Gadgets;
	a1 = Ptr;
	a2 = Req;
	__asm volatile ("
	jsr a6@(-0xde)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2)
	: "d0", "d1", "a0", "a1", "a2");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;*(char*)a2=*(char*)a2;
}
__inline static long RemoveGadget(BASE_PAR_DECL struct Window* RemPtr, struct Gadget* Gadget)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register struct Gadget* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = RemPtr;
	a1 = Gadget;
	__asm volatile ("
	jsr a6@(-0xe4)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;
	return res;
}
__inline static void ReportMouse(BASE_PAR_DECL long Boolean, struct Window* Window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register long d0 __asm("d0");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	d0 = Boolean;
	a0 = Window;
	__asm volatile ("
	jsr a6@(-0xea)"
	: /* no output */
	: "r" (a6), "r" (d0), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static long Request(BASE_PAR_DECL struct Requester* Requester, struct Window* Window)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Requester* a0 __asm("a0");
	register struct Window* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = Requester;
	a1 = Window;
	__asm volatile ("
	jsr a6@(-0xf0)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;
	return res;
}
__inline static void ScreenToBack(BASE_PAR_DECL struct Screen* Screen)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Screen* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Screen;
	__asm volatile ("
	jsr a6@(-0xf6)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void ScreenToFront(BASE_PAR_DECL struct Screen* Screen)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Screen* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Screen;
	__asm volatile ("
	jsr a6@(-0xfc)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static long SetDMRequest(BASE_PAR_DECL struct Window* Window, struct Requester* req)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register struct Requester* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = Window;
	a1 = req;
	__asm volatile ("
	jsr a6@(-0x102)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;
	return res;
}
__inline static void SetMenuStrip(BASE_PAR_DECL struct Window* Window, struct Menu* Menu)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register struct Menu* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = Window;
	a1 = Menu;
	__asm volatile ("
	jsr a6@(-0x108)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;
}
__inline static void SetPointer(BASE_PAR_DECL struct Window* Window, unsigned Pointer, long Height, long Width, long Xoffset, long Yoffset)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register unsigned a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");
	register long d3 __asm("d3");

	a6 = BASE_NAME;
	a0 = Window;
	a1 = Pointer;
	d0 = Height;
	d1 = Width;
	d2 = Xoffset;
	d3 = Yoffset;
	__asm volatile ("
	jsr a6@(-0x10e)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0), "r" (d1), "r" (d2), "r" (d3)
	: "d0", "d1", "a0", "a1", "d2", "d3");
	*(char*)a0=*(char*)a0;
}
__inline static void SetWindowTitles(BASE_PAR_DECL struct Window* window, const char* windowtitle, const char* screentitle)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register const char* a1 __asm("a1");
	register const char* a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = window;
	a1 = windowtitle;
	a2 = screentitle;
	__asm volatile ("
	jsr a6@(-0x114)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2)
	: "d0", "d1", "a0", "a1", "a2");
	*(char*)a0=*(char*)a0;
}
__inline static void ShowTitle(BASE_PAR_DECL struct Screen* Screen, long ShowIt)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Screen* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = Screen;
	d0 = ShowIt;
	__asm volatile ("
	jsr a6@(-0x11a)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void SizeWindow(BASE_PAR_DECL struct Window* window, long dx, long dy)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = window;
	d0 = dx;
	d1 = dy;
	__asm volatile ("
	jsr a6@(-0x120)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static struct View * ViewAddress(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register struct View * res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x126)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static struct View * ViewPortAddress(BASE_PAR_DECL const struct Window* window)
{
	BASE_EXT_DECL
	register struct View * res __asm("d0");
	register void *a6 __asm ("a6");
	register const struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = window;
	__asm volatile ("
	jsr a6@(-0x12c)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void WindowToBack(BASE_PAR_DECL struct Window* window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = window;
	__asm volatile ("
	jsr a6@(-0x132)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void WindowToFront(BASE_PAR_DECL struct Window* window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = window;
	__asm volatile ("
	jsr a6@(-0x138)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static long WindowLimits(BASE_PAR_DECL struct Window* window, long minwidth, long minheight, long maxwidth, long maxheight)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");
	register long d3 __asm("d3");

	a6 = BASE_NAME;
	a0 = window;
	d0 = minwidth;
	d1 = minheight;
	d2 = maxwidth;
	d3 = maxheight;
	__asm volatile ("
	jsr a6@(-0x13e)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1), "r" (d2), "r" (d3)
	: "d0", "d1", "a0", "a1", "d2", "d3");
	*(char*)a0=*(char*)a0;
	return res;
}
__inline static struct Preferences * SetPrefs(BASE_PAR_DECL struct Preferences* preferences, long size, long flag)
{
	BASE_EXT_DECL
	register struct Preferences * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Preferences* a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = preferences;
	d0 = size;
	d1 = flag;
	__asm volatile ("
	jsr a6@(-0x144)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
	return res;
}
__inline static long IntuiTextLength(BASE_PAR_DECL const struct IntuiText* itext)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register const struct IntuiText* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = itext;
	__asm volatile ("
	jsr a6@(-0x14a)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static long WBenchToBack(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x150)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static long WBenchToFront(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x156)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static long AutoRequest(BASE_PAR_DECL struct Window* Window, const struct IntuiText* Body, const struct IntuiText* PText, const struct IntuiText* NText, long PFlag, long NFlag, long W, long H)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register const struct IntuiText* a1 __asm("a1");
	register const struct IntuiText* a2 __asm("a2");
	register const struct IntuiText* a3 __asm("a3");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");
	register long d3 __asm("d3");

	a6 = BASE_NAME;
	a0 = Window;
	a1 = Body;
	a2 = PText;
	a3 = NText;
	d0 = PFlag;
	d1 = NFlag;
	d2 = W;
	d3 = H;
	__asm volatile ("" : /* no input */
	: "r" (a0), "r" (a1));
	__asm volatile ("
	jsr a6@(-0x15c)"
	: "=r" (res)
	: "r" (a6), "r" (a1), "r" (a2), "r" (a3), "r" (d0), "r" (d1), "r" (d2)
	: "d0", "d1", "a0", "a1", "a2", "a3", "d2", "d3");
	*(char*)a0=*(char*)a0;
	return res;
}
__inline static void BeginRefresh(BASE_PAR_DECL struct Window* Window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Window;
	__asm volatile ("
	jsr a6@(-0x162)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static struct Window * BuildSysRequest(BASE_PAR_DECL struct Window* Window, const struct IntuiText* Body, const struct IntuiText* PosText, const struct IntuiText* NegText, long Flags, long W, long H)
{
	BASE_EXT_DECL
	register struct Window * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register const struct IntuiText* a1 __asm("a1");
	register const struct IntuiText* a2 __asm("a2");
	register const struct IntuiText* a3 __asm("a3");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");

	a6 = BASE_NAME;
	a0 = Window;
	a1 = Body;
	a2 = PosText;
	a3 = NegText;
	d0 = Flags;
	d1 = W;
	d2 = H;
	__asm volatile ("" : /* no input */
	: "r" (a0));
	__asm volatile ("
	jsr a6@(-0x168)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2), "r" (a3), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1", "a2", "a3", "d2");
	*(char*)a0=*(char*)a0;
	return res;
}
__inline static void EndRefresh(BASE_PAR_DECL struct Window* Window, long Complete)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = Window;
	d0 = Complete;
	__asm volatile ("
	jsr a6@(-0x16e)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void FreeSysRequest(BASE_PAR_DECL struct Window* Window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Window;
	__asm volatile ("
	jsr a6@(-0x174)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void MakeScreen(BASE_PAR_DECL struct Screen* Screen)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Screen* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Screen;
	__asm volatile ("
	jsr a6@(-0x17a)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void RemakeDisplay(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x180)"
	: /* no output */
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
}
__inline static void RethinkDisplay(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x186)"
	: /* no output */
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
}
__inline static void * AllocRemember(BASE_PAR_DECL struct Remember** RememberKey, long Size, long Flags)
{
	BASE_EXT_DECL
	register void * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Remember** a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = RememberKey;
	d0 = Size;
	d1 = Flags;
	__asm volatile ("
	jsr a6@(-0x18c)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
	return res;
}
__inline static void AlohaWorkbench(BASE_PAR_DECL struct MsgPort* wbport)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct MsgPort* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = wbport;
	__asm volatile ("
	jsr a6@(-0x192)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void FreeRemember(BASE_PAR_DECL struct Remember** RememberKey, long ReallyForget)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Remember** a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = RememberKey;
	d0 = ReallyForget;
	__asm volatile ("
	jsr a6@(-0x198)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static long LockIBase(BASE_PAR_DECL long dontknow)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	d0 = dontknow;
	__asm volatile ("
	jsr a6@(-0x19e)"
	: "=r" (res)
	: "r" (a6), "r" (d0)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void UnlockIBase(BASE_PAR_DECL long IBLock)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register long a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = IBLock;
	__asm volatile ("
	jsr a6@(-0x1a4)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
}
__inline static long GetScreenData(BASE_PAR_DECL char* buffer, long size, long type, struct Screen* screen)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register char* a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register struct Screen* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = buffer;
	d0 = size;
	d1 = type;
	a1 = screen;
	__asm volatile ("
	jsr a6@(-0x1aa)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;
	return res;
}
__inline static void RefreshGList(BASE_PAR_DECL struct Gadget* Gadgets, struct Window* Ptr, struct Requester* Req, long NumGad)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Gadget* a0 __asm("a0");
	register struct Window* a1 __asm("a1");
	register struct Requester* a2 __asm("a2");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = Gadgets;
	a1 = Ptr;
	a2 = Req;
	d0 = NumGad;
	__asm volatile ("
	jsr a6@(-0x1b0)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2), "r" (d0)
	: "d0", "d1", "a0", "a1", "a2");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;*(char*)a2=*(char*)a2;
}
__inline static long AddGList(BASE_PAR_DECL struct Window* AddPtr, struct Gadget* Gadget, long Position, long NumGad, struct Requester* Requester)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register struct Gadget* a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register struct Requester* a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = AddPtr;
	a1 = Gadget;
	d0 = Position;
	d1 = NumGad;
	a2 = Requester;
	__asm volatile ("
	jsr a6@(-0x1b6)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0), "r" (d1), "r" (a2)
	: "d0", "d1", "a0", "a1", "a2");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;*(char*)a2=*(char*)a2;
	return res;
}
__inline static long RemoveGList(BASE_PAR_DECL struct Window* RemPtr, struct Gadget* Gadget, long NumGad)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");
	register struct Gadget* a1 __asm("a1");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = RemPtr;
	a1 = Gadget;
	d0 = NumGad;
	__asm volatile ("
	jsr a6@(-0x1bc)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;
	return res;
}
__inline static void ActivateWindow(BASE_PAR_DECL struct Window* Window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Window;
	__asm volatile ("
	jsr a6@(-0x1c2)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static void RefreshWindowFrame(BASE_PAR_DECL struct Window* Window)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Window* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = Window;
	__asm volatile ("
	jsr a6@(-0x1c8)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*(char*)a0=*(char*)a0;
}
__inline static long ActivateGadget(BASE_PAR_DECL struct Gadget* Gadgets, struct Window* Window, struct Requester* Req)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Gadget* a0 __asm("a0");
	register struct Window* a1 __asm("a1");
	register struct Requester* a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = Gadgets;
	a1 = Window;
	a2 = Req;
	__asm volatile ("
	jsr a6@(-0x1ce)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1), "r" (a2)
	: "d0", "d1", "a0", "a1", "a2");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;*(char*)a2=*(char*)a2;
	return res;
}
__inline static void NewModifyProp(BASE_PAR_DECL struct Gadget* Gadget, struct Window* Ptr, struct Requester* Req, long Flags, long HPos, long VPos, long HBody, long VBody, long NumGad)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Gadget* a0 __asm("a0");
	register struct Window* a1 __asm("a1");
	register struct Requester* a2 __asm("a2");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");
	register long d3 __asm("d3");
	register long d4 __asm("d4");
	register long d5 __asm("d5");

	a6 = BASE_NAME;
	a0 = Gadget;
	a1 = Ptr;
	a2 = Req;
	d0 = Flags;
	d1 = HPos;
	d2 = VPos;
	d3 = HBody;
	d4 = VBody;
	d5 = NumGad;
	__asm volatile ("" : /* no input */
	: "r" (a0), "r" (a1));
	__asm volatile ("
	jsr a6@(-0x1d4)"
	: /* no output */
	: "r" (a6), "r" (a1), "r" (a2), "r" (d0), "r" (d1), "r" (d2), "r" (d3), "r" (d4)
	: "d0", "d1", "a0", "a1", "a2", "d2", "d3", "d4", "d5");
	*(char*)a0=*(char*)a0;*(char*)a1=*(char*)a1;*(char*)a2=*(char*)a2;
}
#undef BASE_EXT_DECL
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME
