#include <inline/stub.h>
#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL extern struct Library * LayersBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME LayersBase
#endif
__inline static void InitLayers(BASE_PAR_DECL struct Layer_Info* li)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = li;
	__asm volatile ("
	jsr a6@(-0x1e)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static struct Layer * CreateUpfrontLayer(BASE_PAR_DECL struct Layer_Info* li, struct BitMap* bm, long x0, long y0, long x1, long y1, long flags, struct BitMap* bm2)
{
	BASE_EXT_DECL
	register struct Layer * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register struct BitMap* a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");
	register long d3 __asm("d3");
	register long d4 __asm("d4");
	register struct BitMap* a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = li;
	a1 = bm;
	d0 = x0;
	d1 = y0;
	d2 = x1;
	d3 = y1;
	d4 = flags;
	a2 = bm2;
	__asm volatile ("" : /* no input */
	: "r" (a0), "r" (a1));
	__asm volatile ("
	jsr a6@(-0x24)"
	: "=r" (res)
	: "r" (a6), "r" (a1), "r" (d0), "r" (d1), "r" (d2), "r" (d3), "r" (d4)
	: "d0", "d1", "a0", "a1", "d2", "d3", "d4", "a2");
	*a0=*a0;*a1=*a1;*a2=*a2;
	return res;
}
__inline static struct Layer * CreateBehindLayer(BASE_PAR_DECL struct Layer_Info* li, struct BitMap* bm, long x0, long y0, long x1, long y1, long flags, struct BitMap* bm2)
{
	BASE_EXT_DECL
	register struct Layer * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register struct BitMap* a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");
	register long d2 __asm("d2");
	register long d3 __asm("d3");
	register long d4 __asm("d4");
	register struct BitMap* a2 __asm("a2");

	a6 = BASE_NAME;
	a0 = li;
	a1 = bm;
	d0 = x0;
	d1 = y0;
	d2 = x1;
	d3 = y1;
	d4 = flags;
	a2 = bm2;
	__asm volatile ("" : /* no input */
	: "r" (a0), "r" (a1));
	__asm volatile ("
	jsr a6@(-0x2a)"
	: "=r" (res)
	: "r" (a6), "r" (a1), "r" (d0), "r" (d1), "r" (d2), "r" (d3), "r" (d4)
	: "d0", "d1", "a0", "a1", "d2", "d3", "d4", "a2");
	*a0=*a0;*a1=*a1;*a2=*a2;
	return res;
}
__inline static long UpfrontLayer(BASE_PAR_DECL struct Layer_Info* li, struct Layer* layer)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register struct Layer* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = li;
	a1 = layer;
	__asm volatile ("
	jsr a6@(-0x30)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
	return res;
}
__inline static long BehindLayer(BASE_PAR_DECL struct Layer_Info* li, struct Layer* layer)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register struct Layer* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = li;
	a1 = layer;
	__asm volatile ("
	jsr a6@(-0x36)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
	return res;
}
__inline static long MoveLayer(BASE_PAR_DECL struct Layer_Info* li, struct Layer* layer, long dx, long dy)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register struct Layer* a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = li;
	a1 = layer;
	d0 = dx;
	d1 = dy;
	__asm volatile ("
	jsr a6@(-0x3c)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
	return res;
}
__inline static long SizeLayer(BASE_PAR_DECL struct Layer_Info* li, struct Layer* layer, long dx, long dy)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register struct Layer* a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = li;
	a1 = layer;
	d0 = dx;
	d1 = dy;
	__asm volatile ("
	jsr a6@(-0x42)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
	return res;
}
__inline static void ScrollLayer(BASE_PAR_DECL struct Layer_Info* li, struct Layer* layer, long dx, long dy)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register struct Layer* a1 __asm("a1");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = li;
	a1 = layer;
	d0 = dx;
	d1 = dy;
	__asm volatile ("
	jsr a6@(-0x48)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
}
__inline static long BeginUpdate(BASE_PAR_DECL struct Layer* layer)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = layer;
	__asm volatile ("
	jsr a6@(-0x4e)"
	: "=r" (res)
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
	return res;
}
__inline static void EndUpdate(BASE_PAR_DECL struct Layer* layer, long flag)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer* a0 __asm("a0");
	register long d0 __asm("d0");

	a6 = BASE_NAME;
	a0 = layer;
	d0 = flag;
	__asm volatile ("
	jsr a6@(-0x54)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (d0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static void DeleteLayer(BASE_PAR_DECL struct Layer_Info* li, struct Layer* layer)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register struct Layer* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = li;
	a1 = layer;
	__asm volatile ("
	jsr a6@(-0x5a)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
}
__inline static void LockLayer(BASE_PAR_DECL struct Layer_Info* li, struct Layer* layer)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register struct Layer* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = li;
	a1 = layer;
	__asm volatile ("
	jsr a6@(-0x60)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
}
__inline static void UnlockLayer(BASE_PAR_DECL struct Layer* layer)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = layer;
	__asm volatile ("
	jsr a6@(-0x66)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static void LockLayers(BASE_PAR_DECL struct Layer_Info* li)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = li;
	__asm volatile ("
	jsr a6@(-0x6c)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static void UnlockLayers(BASE_PAR_DECL struct Layer_Info* li)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = li;
	__asm volatile ("
	jsr a6@(-0x72)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static void LockLayerInfo(BASE_PAR_DECL struct Layer_Info* li)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = li;
	__asm volatile ("
	jsr a6@(-0x78)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static void SwapBitsRastPortClipRect(BASE_PAR_DECL struct RastPort* rp, struct ClipRect* cr)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct RastPort* a0 __asm("a0");
	register struct ClipRect* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = rp;
	a1 = cr;
	__asm volatile ("
	jsr a6@(-0x7e)"
	: /* no output */
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
}
__inline static struct Layer * WhichLayer(BASE_PAR_DECL struct Layer_Info* li, long x, long y)
{
	BASE_EXT_DECL
	register struct Layer * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");
	register long d0 __asm("d0");
	register long d1 __asm("d1");

	a6 = BASE_NAME;
	a0 = li;
	d0 = x;
	d1 = y;
	__asm volatile ("
	jsr a6@(-0x84)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (d0), "r" (d1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
	return res;
}
__inline static void UnlockLayerInfo(BASE_PAR_DECL struct Layer_Info* li)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = li;
	__asm volatile ("
	jsr a6@(-0x8a)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static struct Layer_Info * NewLayerInfo(BASE_PAR_DECL0)
{
	BASE_EXT_DECL
	register struct Layer_Info * res __asm("d0");
	register void *a6 __asm ("a6");
	a6 = BASE_NAME;
	__asm volatile ("
	jsr a6@(-0x90)"
	: "=r" (res)
	: "r" (a6)
	: "d0", "d1", "a0", "a1");
	return res;
}
__inline static void DisposeLayerInfo(BASE_PAR_DECL struct Layer_Info* li)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = li;
	__asm volatile ("
	jsr a6@(-0x96)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static void FattenLayerInfo(BASE_PAR_DECL struct Layer_Info* li)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = li;
	__asm volatile ("
	jsr a6@(-0x9c)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static void ThinLayerInfo(BASE_PAR_DECL struct Layer_Info* li)
{
	BASE_EXT_DECL
	register void *a6 __asm ("a6");
	register struct Layer_Info* a0 __asm("a0");

	a6 = BASE_NAME;
	a0 = li;
	__asm volatile ("
	jsr a6@(-0xa2)"
	: /* no output */
	: "r" (a6), "r" (a0)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;
}
__inline static long MoveLayerInFrontOf(BASE_PAR_DECL struct Layer* layer_to_move, struct Layer* layer_to_be_infront_of)
{
	BASE_EXT_DECL
	register long res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer* a0 __asm("a0");
	register struct Layer* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = layer_to_move;
	a1 = layer_to_be_infront_of;
	__asm volatile ("
	jsr a6@(-0xa8)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
	return res;
}
__inline static struct Region * InstallClipRegion(BASE_PAR_DECL struct Layer* layer, struct Region* region)
{
	BASE_EXT_DECL
	register struct Region * res __asm("d0");
	register void *a6 __asm ("a6");
	register struct Layer* a0 __asm("a0");
	register struct Region* a1 __asm("a1");

	a6 = BASE_NAME;
	a0 = layer;
	a1 = region;
	__asm volatile ("
	jsr a6@(-0xae)"
	: "=r" (res)
	: "r" (a6), "r" (a0), "r" (a1)
	: "d0", "d1", "a0", "a1");
	*a0=*a0;*a1=*a1;
	return res;
}
#undef BASE_EXT_DECL
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME
