/*
 *  This file is part of ixemul.library for the Amiga.
 *  Copyright (C) 1991, 1992  Markus M. Wild
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define KERNEL
#include "ixemul.h"

#ifndef ACTION_SET_FILE_SIZE
#define ACTION_SET_FILE_SIZE 1022
#endif

int
ftruncate (int fd, long len)
{
  struct file *f = u.u_ofile[fd];
  int res;

  errno = EBADF;

  /* if this is an open fd */
  if (fd >= 0 && fd < NOFILE && f)
    {
      if (f->f_type == DTYPE_FILE)
	{
          if (HANDLER_NIL (f))
	    {
	      errno = EINVAL;
	      return -1;
	    }

	  __wait_packet(&f->f_sp);
	  SendPacket3(f, __rwport,ACTION_SET_FILE_SIZE,
                      f->f_fh->fh_Arg1,
                      len, OFFSET_BEGINNING);
	  __wait_packet(&f->f_sp);
	  res = LastResult(f) ? 0 : -1;
	  if (res == -1) errno = __ioerr_to_errno(LastError(f));
	  LastResult(f) = 0;
	  return res;
	}
      else
	errno = ESPIPE;
    }

  return -1;
}
