/*
 *  This file is part of ixemul.library for the Amiga.
 *  Copyright (C) 1991, 1992  Markus M. Wild
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define KERNEL
#include "ixemul.h"

#include <pwd.h>

struct passwd *
getpwnam (const char *name)
{
  static struct passwd pw = { 0, 		/* pw_name */
			      "*",		/* pw_passwd */
			      0,		/* pw_uid */
			      0,		/* pw_gid */
			      0, 		/* pw_change */
			      0,		/* pw_class */
			      "amiga user",	/* pw_gecos */
			      "sys:",		/* pw_dir */
			      "c:execute", 	/* pw_shell */
			      0};		/* pw_expire */

  /* this is not quite safe, since this library function could be called
   * in parallel with different names.. well, I don't consider this worth
   * doing `right', it's here to be able to link some programs ;-) */
  pw.pw_name = name;

  return &pw;
}
