/*
 * definitions of arguments for select() implementation.
 *
 * Each file type that supports select has to look like this:
 *
 *  __..select (f, select_cmd, io_mode)
 *
 */

/*
 * possible values for select_cmd
 */

/* init a select, perhaps initiate a timeout call that can be checked with
 * SELECT_CHECK
 * Return a signal-mask to be used in Wait() that indicates that this file
 * has changed mode.
 */
#define SELCMD_PREPARE	1

/* return whether io_mode on this file won't block */
#define SELCMD_CHECK	2


/*
 * possible values for io_mode
 */

#define SELMODE_IN	0
#define SELMODE_OUT	1
#define SELMODE_EXC	2

/*
 * if PREPARE does a timeout call, use this value (usec) for all these timeouts
 */

#define SELTIMEOUT	100000
