/*
 *  This file is part of ixemul.library for the Amiga.
 *  Copyright (C) 1991, 1992  Markus M. Wild
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define KERNEL
#include "ixemul.h"

#if __GNUC__ != 2
#define alloca __builtin_alloca
#endif

#ifndef LINK_SOFT
#define LINK_SOFT 1
#endif

int
symlink (char *old, char *new)
{
  char *lstr;
  int len;

  /* is long-alignment needed here? This is DOS, isn't it... */
  lstr = alloca (strlen (old) + 3);
  lstr = LONG_ALIGN (lstr);
  strcpy (lstr, old);

  return __make_link (new, lstr, LINK_SOFT) == -1 ? 0 : -1;
}
