/*
 *  This file is part of ixemul.library for the Amiga.
 *  Copyright (C) 1991, 1992  Markus M. Wild
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define KERNEL
#include "ixemul.h"

#define alloca __builtin_alloca

char *
getenv (const char *var)
{
  int fd;
  char *name;
  int len;
#define buf (u.u_getenv_buf)
  
  name = alloca(strlen(var) + sizeof("env:") + 1);
  strcpy(name, "env:");
  strcat(name, var);
  fd = syscall (SYS_open, name, 0);
  if (fd >= 0)
    {
      len = syscall (SYS_read, fd, buf, 255);
      if (len >= 0) buf[len] = 0;
      syscall (SYS_close, fd);
      return buf;
    }
  return NULL;
}
