/*
 *  This file is part of ixemul.library for the Amiga.
 *  Copyright (C) 1991, 1992  Markus M. Wild
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define KERNEL
#include "ixemul.h"

#define alloca __builtin_alloca

int
setenv (const char *var, const char *val, ...)
{
  int fd;
  char *name;
  int result = -1;
  
  name = alloca (strlen(var) + sizeof("env:") + 1);
  strcpy(name, "env:");
  strcat(name, var);
  fd = syscall (SYS_open, name, O_WRONLY|O_CREAT|O_TRUNC, 0666);
  if (fd >= 0)
    {
      syscall (SYS_write, fd, val, strlen (val));
      syscall (SYS_close, fd);
      result = 0;
    }
  return result;
}
